//+------------------------------------------------------------------+
//| 	         						   EA TEST noTradeWindow.mq4 |
//+------------------------------------------------------------------+
#property show_inputs

//#include <stdlib.mqh>
//#include <stderror.mqh>


//---------------------
//	EA Startup Values
//---------------------
//Can be altered when EA is running on chart by:
//1. <F7> -> Inputs tab or,
//2. RtClick in chart -> Expert Advisors -> Properties... -> Inputs tab
//
//String value of date/time format as:
//									 "yyyy.mm.dd hh:mi:ss"
extern datetime edtStartNoTrade	=	D'2007.09.13 09:06:00';
extern datetime edtEndNoTrade	=	D'2007.09.13 09:09:00';
extern bool ebShowLatestServerClosePrice = TRUE;	//display Close[0] in chart comment area - demonstrates that EA called each tic


//--------------------------------
//	EA Module Global Definitions
//--------------------------------
string gsComment;							//holds text for chart Comment() area
bool gbRESET;								//force ALL module static/state memory to compile time settings when init() called.
											//	*if* previous launch closure (deinit() called) was due to REASONS
											//	REASON_PARAMETERS or REASON_CHARTCHANGE beware! Since this EAs
											//	static/state memory *will not* be reset to compile time settings.
											//---------------------------------------------------------------------
//
//+------------------------------------------------------------------+
//
int init()
{
	gsComment = StringConcatenate("init(): Start_NO_Trade at ",TimeToStr(edtStartNoTrade,TIME_DATE|TIME_MINUTES|TIME_SECONDS)
				,",  End_NO_Trade at ",TimeToStr(edtEndNoTrade,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
			
	Print("init(): Previous Launch had UninitializeReason()=\"",sfGetUnInitReason(),"\"");
	Print(gsComment);
	Comment(gsComment);

	//----------------------------------------------------------------
	//	ALLWAYS RESET STATIC MEMORY TO INITIAL COMPILE TIME SETTINGS
	//----------------------------------------------------------------
	//
	gbRESET = TRUE;							//forces start() to reset static/state memory

	return(0);
}
//
//+------------------------------------------------------------------+
//
int deinit()
{
	Print("deinit(): UninitializeReason()=\"",sfGetUnInitReason(),"\"");
	Comment("");

	return(0);
}
//
//+------------------------------------------------------------------+
//
int start()
{
	static bool sbPrintDoNotTrade = TRUE;	//toggles to stop multiple Print()'s clogging up Experts tab log
	static bool sbPrintOkToTrade = TRUE;	//..
	static string ssToTradeOrNotTrade = "Trade/NotTrade State Unknown";
	datetime dtNow = TimeLocal();			//get current LOCAL time for comparison with EA extern values
	
	//---------------------------------------------------------------------
	//	*if init() called*
	//	ALLWAYS RESET STATIC MEMORY TO INITIAL COMPILE TIME SETTINGS
	//
	//	*if* previous launch closure (deinit() called) was due to REASONS
	//	REASON_PARAMETERS or REASON_CHARTCHANGE beware! Since this EAs
	//	static/state memory *will not* be reset to compile time settings.
	//---------------------------------------------------------------------
	//
	if( gbRESET )
	{
		gbRESET = FALSE;					//do not come this way again until next time init() called
		//now reset all start()'s static/state memory to compile time settings (skip extern's, user may have altered!)
		sbPrintDoNotTrade = TRUE;
		sbPrintOkToTrade = TRUE;
		ssToTradeOrNotTrade = "Trade/NotTrade State Unknown";
	}


	if( dtNow >= edtStartNoTrade && dtNow <= edtEndNoTrade )
	{
		//if here, then time is INSIDE NO TRADE window
		//
		if( sbPrintDoNotTrade )
		{
			ssToTradeOrNotTrade = "DO NOT TRADE";
			Print(ssToTradeOrNotTrade);
			sbPrintDoNotTrade = FALSE;		//disable after first time here
			sbPrintOkToTrade = TRUE;		//enable opposite state's print when leave this state
		}
	}
	else
	{
		//if here, then time is OUTSIDE NO TRADE window
		//
		if( sbPrintOkToTrade )
		{
			ssToTradeOrNotTrade = "OK TO TRADE";
			Print(ssToTradeOrNotTrade);
			sbPrintOkToTrade = FALSE;		//disable after first time here
			sbPrintDoNotTrade = TRUE;		//enable opposite state's print when leave this state
		}
	}
		
	if( ebShowLatestServerClosePrice )
		Comment(gsComment,"\n",ssToTradeOrNotTrade,"\nLocalTime "
				,TimeToStr(dtNow,TIME_DATE|TIME_MINUTES|TIME_SECONDS),",  Latest Close = ",Close[0]);
	else
		Comment(gsComment,"\n",ssToTradeOrNotTrade);

	return(0);
	
}//start()
//
//+------------------------------------------------------------------+
//
string sfGetUnInitReason()
{
	string s;
	switch(UninitializeReason())
	{
		case 0:						s = "REASON_SELF_INITIATED_EXIT"; break;
		case REASON_REMOVE:    		s = "REASON_REMOVE"; break;
		case REASON_RECOMPILE:		s = "REASON_RECOMPILE"; break;
		case REASON_CHARTCHANGE:	s = "REASON_CHARTCHANGE"; break;
		case REASON_CHARTCLOSE:		s = "REASON_CHARTCLOSE"; break;
		case REASON_PARAMETERS:		s = "REASON_PARAMETERS"; break;
		case REASON_ACCOUNT:  		s = "REASON_ACCOUNT"; break;
		default:
			s = "unexplainedReason!";
			break;
	}
	return(s);
}
//
//+------------------------------------------------------------------+
//

